      subroutine output_av(u,ep,sg,ngng,nmte,neus,nnus,nn)
      include 'para.inc'
      include 'const.inc'
      dimension u(*),sg(icom,nte,*),ep(icom,nte,*),ngng(*)
      dimension neus(*),nnus(*)
      dimension nmte(*),nn(inmte,*)
c     
c  sglocal(jj,ii) local stress -> ii:node number(local),jj:component
c  nsgav(i) :  summation number of global node i
c  sgn(j,i) :  j:component i:node number(global)
      dimension sglocal(icom,4),eplocal(icom,4)
      dimension sgn(icom,inode),epn(icom,inode)
      dimension nsgav(inode)
c
      dimension qc84(4,4),qc89(4,4)
c
      data qc84(1,1),qc84(1,2),qc84(1,3),qc84(1,4)
     & /0.1866026e+01,-0.5000000e+00,0.1339748e+00,-0.5000000e+00/
      data qc84(2,1),qc84(2,2),qc84(2,3),qc84(2,4)
     & /-0.5000000e+00,0.1866026e+01,-0.5000000e+00,0.1339748e+00/
      data qc84(3,1),qc84(3,2),qc84(3,3),qc84(3,4)
     & /0.1339748e+00,-0.5000000e+00,0.1866026e+01,-0.5000000e+00/
      data qc84(4,1),qc84(4,2),qc84(4,3),qc84(4,4)
     & /-0.5000000e+00,0.1339748e+00,-0.5000000e+00,0.1866026e+01/
c
      data qc89(1,1),qc89(1,2),qc89(1,3),qc89(1,4)
     & /0.1312164e+01,-0.1666667e+00,0.2116944e-01,-0.1666667e+00/
      data qc89(2,1),qc89(2,2),qc89(2,3),qc89(2,4)
     & /-0.1666667e+00,0.1312164e+01,-0.1666667e+00,0.2116944e-01/
      data qc89(3,1),qc89(3,2),qc89(3,3),qc89(3,4)
     & /0.2116944e-01,-0.1666667e+00,0.1312164e+01,-0.1666667e+00/
      data qc89(4,1),qc89(4,2),qc89(4,3),qc89(4,4)
     & /-0.1666667e+00,0.2116944e-01,-0.1666667e+00,0.1312164e+01/
c
      do 1 k = 1 , ntn
         nsgav(k)=0.0
          do 2 j = 1 , icom
            sgn(j,k)=0.0
 2        continue
 1    continue
c
      do 3 i = 1,4
      do 4 j = 1,icom
       sglocal(j,i)=0.0
 4    continue
 3    continue
c
c  ep(l,in,kk) ,sg(l,in,kk) 
c   l : component s11,s22,s33,s12 ...
c  in : element number
c  kk : integration point number
c
      do 100 in = 1,nte
      nmin = nmte(in)
      ngin = ngng(in)
      if (((nmin.eq.4).or.(nmin.eq.8)).and.(ngin.eq.4)) then
cccc set matrix (8node ngauss=2)
c  sglocal(jj,ii) -> ii : node number(local) , jj : component
      do 120 ii = 1,4
c      do 110  k = 1,4
      do 130 jj = 1,icom
cc  4<->3 exchange
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,1)*sg(jj,in,1)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,2)*sg(jj,in,2)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,3)*sg(jj,in,4)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,4)*sg(jj,in,3)
c
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,1)*ep(jj,in,1)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,2)*ep(jj,in,2)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,3)*ep(jj,in,4)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,4)*ep(jj,in,3)
c
 130  continue
c 110  continue
c        write(99,*)in,ii,sglocal(2,ii),' component',icom
c  local node --> global node
c  nn(ii,in) ii:node number(local) in:element number 
c            nn:global node number
c  nsgav(i) :  summation number of global node i
c  sgn(j,i) :  j:component i:node number(global)
        nglob = nn(ii,in)
        nsgav(nglob) =  nsgav(nglob) + 1.0
      do 140 jj = 1,icom
        sgn(jj,nglob) = sgn(jj,nglob) +  sglocal(jj,ii)
        epn(jj,nglob) = epn(jj,nglob) +  eplocal(jj,ii)
 140  continue
c
 120  continue
c
      else
      if (((nmin.eq.4).or.(nmin.eq.8)).and.(ngin.eq.9)) then
cccc set matrix (8node ngauss=3)
c  sglocal(jj,ii) -> ii : node number(local) , jj : component
      do 125 ii = 1,4
c      do 115  k = 1,4
      do 135 jj = 1,icom
cc  1<->1 2<->3 3<->9 4<->7 exchange
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,1)*sg(jj,in,1)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,2)*sg(jj,in,3)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,3)*sg(jj,in,9)
       sglocal(jj,ii) = sglocal(jj,ii) + qc84(ii,4)*sg(jj,in,7)
c
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,1)*ep(jj,in,1)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,2)*ep(jj,in,3)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,3)*ep(jj,in,9)
       eplocal(jj,ii) = eplocal(jj,ii) + qc84(ii,4)*ep(jj,in,7)
c       sglocal(jj,ii) = sglocal(jj,ii) + qc89(ii,k)*sg(jj,in,k)
c       eplocal(jj,ii) = eplocal(jj,ii) + qc89(ii,k)*ep(jj,in,k)
 135  continue
c 115  continue
c  local node --> global node
c  nn(ii,in) ii:node number(local) in:element number 
c            nn:global node number
c  nsgav(i) :  summation number of global node i
c  sgn(j,i) :  j:component i:node number(global)
        nglob = nn(ii,in)
        nsgav(nglob) =  nsgav(nglob) + 1
      do 145 jj = 1,icom
        sgn(jj,nglob) = sgn(jj,nglob) +  sglocal(jj,ii)
        epn(jj,nglob) = epn(jj,nglob) +  eplocal(jj,ii)
 145  continue
 125  continue
c
      else
       write(6,*)'no support!'
       stop
      endif
      endif
c
      do 400 i = 1,4
      do 410 j = 1,icom
       sglocal(j,i) = 0.0
       eplocal(j,i) = 0.0
 410  continue
 400  continue
c
 100  continue
c
      write(2,*)'averaged at node (stress)'
      do 300 in=1,ntn
      inout = nnus(in)
      nw = nsgav(in)
      if (nw.ne.0) write(2,211)inout,(sgn(l,in)/nw,l=1,icom)
c      write(2,211)inout,(sgn(l,in),l=1,icom),nw
 300  continue
c      
      write(2,*)
      write(2,*)'averaged at node (strain)'
      do 310 in=1,ntn
      inout = nnus(in)
      nw = nsgav(in)
      if (nw.ne.0) write(2,211)inout,(epn(l,in)/nw,l=1,icom)
c      write(2,211)inout,(sgn(l,in),l=1,icom),nw
 310  continue
c      
c
 211  format(1h i5,4(1x,e15.7),i2)
 201  format(1h ,2i5,4(1x,e15.7))
 200  format(1h ,i5,4(1x,e15.7))
      return
      end
