      subroutine data(a,nmte,econ,t,nn,x,y,
     +     ifor,fb,idis,ub,ngng,nom,iecon,neus,nnus)
      include 'para.inc'
      include 'const.inc'
      dimension nmte(*),nn(inmte,*),x(*),y(*),ifor(*),idis(*),fb(*),
     +     ub(*),nom(*),econ(9,*),ngng(*),iecon(*)
      dimension neus(*),nnus(*)
      open(1,file='input.dat')
c
      read(1,*)ngauss
      read(1,*)npara,t,mnum
c+++++++++++++++++++++++++++++++++++++
      write(77,*)'data check'
      if (npara.eq.0) write(77,*)'plane stress analysis'
      if (npara.eq.1) write(77,*)'plane strain analysis'
      if (npara.eq.2) write(77,*)'axial symmerty analysis'
      write(77,*)'thickness =   ',t
      write(77,*)'number of material =   ',mnum
      write(77,*)'integration order =    ',ngauss
c+++++++++++++++++++++++++++++++++++++
c--analysis condition------------
c npara=0 --> plane stress
c npara=1 --> plane strain
c npara=2 --> axial symmetry
c--------------------------------
c*elastic constants 
c  iecon = 1 --> isotropic
c    econ(1,l)=young module , econ(2,l)=poisson ratio
c  iecon = 2 --> orthotropic
c    econ(1,l)=c11 econ(2,l)=c22 econ(3,l)=c33 econ(4,l)=c44
c    econ(5,l)=c55 econ(6,l)=c66 econ(7,l)=c12 econ(8,l)=c13 
c    econ(9,l)=c23  12->4 13->5 23->6
      do 5 l=1,mnum
	 read(1,*)iecon(l)
         iec=iecon(l)
	 if (iec.eq.1)  then
          read(1,*)mn,econ(1,l),econ(2,l)
c+++++++++++++++++++++++++++++++++++++
          write(77,*)'material',l
          write(77,*)'young=',econ(1,l),', poisson=',econ(2,l)
c+++++++++++++++++++++++++++++++++++++
          else
	 if (iec.eq.2)  then
           read(1,*)mn,econ(1,l),econ(2,l),econ(3,l)
     +                ,econ(4,l),econ(5,l),econ(6,l)
     +                ,econ(7,l),econ(8,l),econ(9,l)
c+++++++++++++++++++++++++++++++++++++
          write(77,*)'material',l
      write(77,*)'c11=',econ(1,l),', c22=',econ(2,l),', c33=',econ(3,l)
      write(77,*)'c44=',econ(4,l),', c55=',econ(5,l),', c66=',econ(6,l)
      write(77,*)'c12=',econ(7,l),', c13=',econ(8,l),', c23=',econ(9,l)
c+++++++++++++++++++++++++++++++++++++
         endif
         endif
 5    continue
c
      read(1,*)ntn,nte
      ntf=ntn*idim
c+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'total nodes    =   ',ntn
      write(77,*)'total elements =   ',nte
      write(77,*)'total freedoms =   ',ntf
c+++++++++++++++++++++++++++++++++++++++++
      nna=0
      do 20 ie=1,nte
         read(1,*)ii,nom(ie),nmte(ie)
c*sort ie : program element number , neus(ie) : user element number
         neus(ie)=ii
c---- 6 nodes triangle
         if(nmte(ie).eq.6) then
           ngng(ie)=ngauss+1
           read(1,*)nn(1,ie),nn(2,ie),nn(3,ie),nn(4,ie),
     +              nn(5,ie),nn(6,ie)
c+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'element',ie,':  material'
     +                         ,nom(ie),' : 6 nodes triangle'
c+++++++++++++++++++++++++++++++++++++++++
c---- 8 nodes rectangle(quadrangle)
         else if(nmte(ie).eq.8) then
           read(1,*)nn(1,ie),nn(2,ie),nn(3,ie),nn(4,ie),
     +              nn(5,ie),nn(6,ie),nn(7,ie),nn(8,ie) 
           ngng(ie)=ngauss*ngauss
c+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'element',ie,':  material',nom(ie)
     +                           ,' : 8 nodes rectangle'
c+++++++++++++++++++++++++++++++++++++++++
c---- 4 nodes rectangle
         else if(nmte(ie).eq.4) then
           read(1,*)nn(1,ie),nn(2,ie),nn(3,ie),nn(4,ie)
           ngng(ie)=ngauss*ngauss
c+++++++++++++++++++++++++++++++++++++++++
      write(77,*)'element',ie,':  material',nom(ie)
     +                           ,' : 4 nodes rectangle'
c+++++++++++++++++++++++++++++++++++++++++
         endif
         nna=nna+ngng(ie)
 20   continue
c+++++++++++++++++++++++++++++++++++++++++
        write(77,*)'total int.points =   ',nna
        write(77,*)'coordinate of nodes'
        write(77,*)'pro.num. , usr num. ,coordination of nodes'
c+++++++++++++++++++++++++++++++++++++++++
      do 40 i=1,ntn
         read(1,*)jj,x(i),y(i)
        write(77,112)i,jj,x(i),y(i)
c*sort i : program node number , nnus(i) : user node number
         nnus(i)=jj
 40   continue
c+++++++++++++++++++++++++++++++++++++++++
 112  format(2(i4,x),2e15.7)
c      
      write(77,*)'*element node is reconstructed'
c
      do 200 ie=1,nte
        nmie=nmte(ie)
        write(77,*)'user   ',(nn(j3,ie),j3=1,nmie)
c
       do 210 j2 = 1,nmie
        nnj2 = nn(j2,ie)
        do 220 i2 = 1,ntn
           kk = nnus(i2)
           if ( kk.eq.nnj2 ) then
            nn(j2,ie) = i2
           go to 210
           endif
 220    continue
          write(6,*)'no match'
          stop
 210    continue
        write(77,*)'program',(nn(j3,ie),j3=1,nmie)
c
 200  continue
c
      write(77,*)'*force boundary'
c
      read(1,*)ntfor
      if(ntfor.lt.1) go to 51
      do 50 i=1,ntfor
         read(1,*)ifo,ixy,ff
c  ifo(user node number) --> ifop(program node number)
         do 55 i2 = 1,ntn
           kk=nnus(i2)            
         if ( kk.eq.ifo ) then
           ifop=i2
           go to 56
         endif
 55      continue
            write(77,*)'invalid boundary condition!(no node)'
            write(6,*)'error!!'
            stop
 56      continue
c         write(6,*)ifo,ifop
c------------------------------------------
         if (ixy.gt.idim) then
            write(77,*)'invalid boundary condition!(ixy.gt.idim)'
            write(6,*)'error'
            go to 51
         endif
         nfree = (ifop-1)*idim + ixy
          ifor(i)=nfree
          fb(i) = ff
          if (ixy.eq.1) write(77,*)'node',ifo,'-->fx=',fb(i),nfree
          if (ixy.eq.2) write(77,*)'node',ifo,'-->fy=',fb(i),nfree
c
 50   continue
 51   continue
c
      write(77,*)'*displacement boundary'
      read(1,*)ntdis
      if(ntdis.lt.1) go to 61
      do 60 i=1,ntdis
         read(1,*)idi,ixy,uu
c  idi(user node number) --> idip(program node number)
         do 65 i2 = 1,ntn
           kk=nnus(i2)            
         if ( kk.eq.idi ) then
           idip=i2
           go to 66
         endif
 65      continue
            write(77,*)'invalid boundary condition!(no node)'
            write(6,*)'error!!'
            stop
 66      continue
c         write(6,*)idi,idip
c------------------------------------------
         if (ixy.gt.idim) then
            write(77,*)'invalid boundary condition!(ixy.gt.idim)'
            write(6,*)'error'
            go to 61
         endif
         nfree = (idip-1)*idim + ixy
          idis(i)=nfree
          ub(i) = uu
          if (ixy.eq.1) write(77,*)'node',idi,'-->ux=',ub(i),nfree
          if (ixy.eq.2) write(77,*)'node',idi,'-->uy=',ub(i),nfree
 60   continue
 61   continue
      close(1)
c      
      return
      end
