      subroutine dmat(econ,d,nom,iecon)
      include 'para.inc'
      include 'const.inc'
      dimension d(icom,icom),econ(9,*),nom(*),iecon(*)
c
cccc 2dimensional d-matrix
      k=nom(ie)
      ieck = iecon(k)
c
c------------------------
c  isotropic
c------------------------
      if (ieck.eq.1) then
      eyo=econ(1,k)
      epo=econ(2,k)
c      
      do 10 i=1,2
         d(4,i)=0
         d(i,4)=0
         d(i,i)=1.0
 10   continue
      
      do 15 i=1,4
         d(3,i)=0
         d(i,3)=0
 15   continue   
      
      if(npara.eq.0) then
         d(1,2)=epo
         d(2,1)=epo
         d(4,4)=(1.0-epo)/2.0
         do 20 i=1,4
            do 30 j=1,4
               d(i,j)=eyo/(1.0-epo*epo)*d(i,j)
 30         continue
 20      continue
         
      else if(npara.eq.1) then
         d(1,2)=epo/(1-epo)
         d(2,1)=epo/(1-epo)
         d(4,4)=(1.0-2.0*epo)/(2.0*(1-epo))
         do 40 i=1,4
            do 50 j=1,4
               d(i,j)=eyo*(1-epo)/((1.0+epo)*(1.0-2.0*epo))*d(i,j)
 50         continue
 40      continue
c         
      else
ccccc axial symmetry part is modified by izumi
c         do 60 i=1,3
c            do 70 j=1,3
c               d(i,j)=epo
c 70         continue
c 60      continue
c         do 80 i=1,3
c            d(4,i)=0
c            d(i,4)=0
c            d(i,i)=1-epo
c 80      continue
         d12=epo/(1-epo)
         d(1,2)=d12
         d(2,1)=d12
         d(1,3)=d12
         d(3,1)=d12
         d(2,3)=d12
         d(3,2)=d12
         d(3,3)=1.0
         d(4,4)=(1.0-2.0*epo)/(2.0*(1-epo))
c         
         do 90 i=1,4
            do 100 j=1,4
               d(i,j)=eyo*(1.0-epo)/((1.0+epo)*(1.0-2.0*epo))*d(i,j)
 100        continue
 90      continue
      end if
c
      else
c------------------------
c  orthotropic
c------------------------
      if (ieck.eq.2) then
c
      c11=econ(1,k)
      c22=econ(2,k)
      c33=econ(3,k)
      c44=econ(4,k)
      c55=econ(5,k)
      c66=econ(6,k)
      c12=econ(7,k)
      c13=econ(8,k)
      c23=econ(9,k)
c
      do 500 i=1,2
         d(4,i)=0
         d(i,4)=0
         d(i,i)=1.0
 500  continue
c      
      do 550 i=1,4
         d(3,i)=0
         d(i,3)=0
 550  continue   
c      
      if(npara.eq.0) then
        d11 = (c11*c33-c13*c13)/c33
        d12 = (c12*c33-c13*c23)/c33
        d22 = (c22*c33-c23*c23)/c33
        d44 =  c44
         d(1,1)=d11
         d(2,2)=d22
         d(1,2)=d12
         d(2,1)=d12
         d(4,4)=d44
      else if(npara.eq.1) then
         d(1,1)=c11
         d(2,2)=c22
         d(1,2)=c12
         d(2,1)=c12
         d(4,4)=c44
      else  if(npara.eq.2) then
         write(6,*)'no support!'
         stop
      endif
c
      endif
      endif
c      
ccc for program check
cc      write(77,*)'d-matrix'
cc      do 200 i = 1,4
cc      write(77,111)(d(i,j),j=1,4)
cc 200  continue
cc 111  format(4e15.7)
c
      return
      end                          
